/******************************************************************************** 
    Desarrollado por:   Avanxo México
    Autor:              Héctor Figueroa
    Proyecto:           TOYOTA TAM
    Descripción:        Clase controladora para el componente TAM_AdminVisibInventarioToyota

    Infomación de cambios (versiones)
    ===============================================================================
    No.    Fecha                Autor                       Descripcion
    1.0    22-Marzo-2021        Héctor Figueroa             Creación
******************************************************************************* */

public without sharing class TAM_AdminVisibInventarioToyota {

    //Consulta los datos de los distrubuidores
    static List<Account> setDistrib = new List<Account>();

    static List<String> setFuncDistPrincFin = new List<String>{'Ejecutivo','Gestor','Asesor'};
    static List<String> setTiposInvenDistPrincFin = new List<String>{'Producción','Tráfico','Piso'};
    static List<Account> setDistRelFin = setDistrib;
    static List<String> setFuncDistrRelFin = new List<String>{'Ejecutivo','Gestor','Asesor'};
    static List<String> setTipoInvenDistRelFin = new List<String>{'Producción','Tráfico','Piso'};
    
    static List<wrpMapDatosDist> lWrpMapDatosDist = new List<wrpMapDatosDist>();
    
    public class wrpMapDatosDist{
        @AuraEnabled public String NumeroDist {get;set;}
        @AuraEnabled public String NombreDist {get;set;}    
        @AuraEnabled public Boolean blnMuestra {get;set;}
        @AuraEnabled public Boolean blnDefaultColaboraGrupo {get;set;}
        @AuraEnabled public Boolean blnModDistRel {get;set;}
        @AuraEnabled public Boolean blnTieneReglas {get;set;}
        @AuraEnabled public Boolean blnBlocDistRel {get;set;}
        @AuraEnabled public List<String> setDistrRel {get;set;}
        @AuraEnabled public List<String> setSelectDistrRel {get;set;}
        @AuraEnabled public List<String> setFuncDistPrinc {get;set;}
        @AuraEnabled public List<String> setSelectFuncDistPrinc {get;set;}
        @AuraEnabled public List<String> setTiposInvenDistPrinc {get;set;}        
        @AuraEnabled public List<String> setSelectTiposInvenDistPrinc {get;set;}
        @AuraEnabled public List<Account> setDistRel {get;set;}
            
        //Un contructor por default
        public wrpMapDatosDist(){
            this.NumeroDist = '';
            this.NombreDist = '';
            this.blnMuestra = false;
            this.blnDefaultColaboraGrupo = false;
            this.blnModDistRel = false;
            this.blnTieneReglas = false;
            this.blnBlocDistRel = false;
            this.setDistrRel = new List<String>();
            this.setSelectDistrRel = new List<String>();
            this.setFuncDistPrinc = new List<String>();
            this.setSelectFuncDistPrinc = new List<String>();
            this.setTiposInvenDistPrinc = new List<String>();
            this.setSelectTiposInvenDistPrinc = new List<String>();
            this.setDistRel = new List<Account>();
        }
    }

    public class wrpMapDatosDistSelec{
        @AuraEnabled public String NumeroDist {get;set;}
        @AuraEnabled public String NombreDist {get;set;}
        @AuraEnabled public String setSelectDistrRel {get;set;}
        @AuraEnabled public String setSelectFuncDistPrinc {get;set;}
        @AuraEnabled public String setSelectTiposInvenDistPrinc {get;set;}
            
        //Un contructor por default
        public wrpMapDatosDistSelec(){
            this.NumeroDist = '';
            this.NombreDist = '';            
            this.setSelectDistrRel = '';
            this.setSelectFuncDistPrinc = '';
            this.setSelectTiposInvenDistPrinc = '';
        }   
    }

    public class wrpMapDatosDistSelecFinal{
        @AuraEnabled public String NumeroDist {get;set;}
        @AuraEnabled public String NombreDist {get;set;}    
        @AuraEnabled public Boolean blnMuestra {get;set;}
        @AuraEnabled public Boolean blnDefaultColaboraGrupo {get;set;}
        @AuraEnabled public Boolean blnModDistRel {get;set;}
        @AuraEnabled public Boolean blnTieneReglas {get;set;}
        @AuraEnabled public List<String> setSelectDistrRel {get;set;}
            
        //Un contructor por default
        public wrpMapDatosDistSelecFinal(){
            this.NumeroDist = '';
            this.NombreDist = '';
            this.blnMuestra = false;
            this.blnDefaultColaboraGrupo = false;
            this.blnModDistRel = false;
            this.blnTieneReglas = false;
            this.setSelectDistrRel = new List<String>();
        }   
    }

    public class wrpReglaColabora{
        @AuraEnabled public String NumeroDist {get;set;}
        @AuraEnabled public String NombreDist {get;set;}
        @AuraEnabled public List<String> setSelectFuncDistPrinc {get;set;}
        @AuraEnabled public List<String> setSelectTiposInvenDistPrinc {get;set;}
        @AuraEnabled public String lstSelectFuncDistPrinc {get;set;}
        @AuraEnabled public String ltsSelectTiposInvenDistPrinc {get;set;}
        @AuraEnabled public Boolean blnExisteRegla {get;set;}
        @AuraEnabled public Boolean blnNoExisteFunOInvent {get;set;}
        @AuraEnabled public Integer intNoRegla {get;set;}
            
        //Un contructor por default
        public wrpReglaColabora(){
            this.NumeroDist = '';
            this.NumeroDist = '';
            this.setSelectFuncDistPrinc = new List<String>();
            this.setSelectTiposInvenDistPrinc = new List<String>();
            this.lstSelectFuncDistPrinc = '';
            this.ltsSelectTiposInvenDistPrinc = '';
            this.blnExisteRegla = false;
            this.intNoRegla = 0;
        }   
    }


    @AuraEnabled
    public static List<Account> getDistDispCons(String recordId){
        System.debug('EN getDistDispCons...');
        List<Account> setDistCons = new List<Account>();
         
        //Consulta todos los reg de los Dist 
        for (Account objDist : [SELECT Id, Name, Codigo_Distribuidor__c 
            FROM Account WHERE RecordType.Name = 'Distribuidor'
            AND Venta_Corporativa__c = 'Si' AND EstatusDealer__c = 'Activo'
            //AND Asignado_a_autos_Pool__c = true 
            ORDER BY Name ASC]){
            //Agrega el registro del Dist a la list de lWrpMapDatosDist
            setDistCons.add(objDist);
        }

        System.debug('EN getDistDispCons setDistCons: ' + setDistCons);         
        return setDistCons;
    }

    @AuraEnabled
    public static Account getDatosDistCons(String recordId){
        System.debug('EN getDistDispCons...');
        Account objDistCons = new Account();
        User usuarioCons = new User();
        
        for (User usuaruiCons: [Select id, CodigoDistribuidor__c From User Where id =:UserInfo.getUserId()]){
            usuarioCons = usuaruiCons;
        }
        System.debug('EN getDistDispCons usuarioCons: '  + usuarioCons);

        //Consulta todos los reg de los Dist 
        for (Account objDist : [SELECT Id, Name, Codigo_Distribuidor__c 
            FROM Account WHERE RecordType.Name = 'Distribuidor'
            AND Venta_Corporativa__c = 'Si' AND EstatusDealer__c = 'Activo'
            AND Codigo_Distribuidor__c =: usuarioCons.CodigoDistribuidor__c]){
            //Agrega el registro del Dist a la list de lWrpMapDatosDist
            objDistCons = objDist;
        }

        System.debug('EN getDistDispCons objDistCons: ' + objDistCons);         
        return objDistCons;
    }

    @AuraEnabled
    public static List<wrpMapDatosDist> getDatosDistribInv(String recordId, List<Account> lstDistrRel){
        System.debug('EN getDatosDistribInv lstDistrRel: ' + lstDistrRel);
        List<wrpMapDatosDist> lWrpMapDatosDist = new List<wrpMapDatosDist>();
        Set<String> setCveDea = new Set<String>();
        Set<String> setCveDeaEnAdminInv = new Set<String>();
        Map<String, Boolean> mapCodDistObj = new Map<String, Boolean>(); 
        TAM_AdminInventarioDealer__c objAdminInvAppDefault = new TAM_AdminInventarioDealer__c();
        TAM_AdminInventarioDealer__c objAdminInvNoAppDefault = new TAM_AdminInventarioDealer__c();
        
        //Consulta todos los reg de los Dist 
        for (Account strDist : lstDistrRel){
            if (strDist.Codigo_Distribuidor__c != null)
                setCveDea.add(strDist.Codigo_Distribuidor__c);
        }
        System.debug('EN getDatosDistribInv setCveDea: ' + setCveDea);

        //Consulta los datos del setCveDea en TAM_AdminInventarioDealer__c 
        for (TAM_AdminInventarioDealer__c objAdminInvDeal : [Select t.id, t.Name, t.TAM_TipoInventario__c, 
            t.TAM_Funcion__c, t.TAM_DistribuidorAsociado__c, t.TAM_AplicaColarobarionDefault__c, t.TAM_CodigoDistribuidor__c 
            From TAM_AdminInventarioDealer__c t where TAM_CodigoDistribuidor__c IN :setCveDea]){
            Boolean blnModDatos = true;
            //Metelo al mapa de mapCodDistObj
            mapCodDistObj.put(objAdminInvDeal.TAM_CodigoDistribuidor__c, blnModDatos);
            //Metelo a la lista de setCveDeaEnAdminInv
            if (objAdminInvDeal.TAM_DistribuidorAsociado__c == null && objAdminInvDeal.TAM_Funcion__c == null
                && objAdminInvDeal.TAM_TipoInventario__c == null){
                blnModDatos = false;
                objAdminInvAppDefault = objAdminInvDeal;
            }
            if (objAdminInvDeal.TAM_DistribuidorAsociado__c != null || objAdminInvDeal.TAM_Funcion__c != null
                || objAdminInvDeal.TAM_TipoInventario__c != null){
                blnModDatos = false;
                objAdminInvNoAppDefault = objAdminInvDeal;
            }
            //Metelo al mapa de mapCodDistObj
            mapCodDistObj.put(objAdminInvDeal.TAM_CodigoDistribuidor__c, blnModDatos);
        }
        System.debug('EN getDatosDistribInv setCveDeaEnAdminInv: ' + setCveDeaEnAdminInv);        
        System.debug('EN getDatosDistribInv mapCodDistObj: ' + mapCodDistObj);        
                         
        //Consulta todos los reg de los Dist 
        for (Account strDist : lstDistrRel){
            //Agrega el registro del Dist a la list de lWrpMapDatosDist
            wrpMapDatosDist objWrpMapDatosDistPaso = new wrpMapDatosDist();
            objWrpMapDatosDistPaso.NumeroDist = strDist.Codigo_Distribuidor__c;
            objWrpMapDatosDistPaso.NombreDist = strDist.Name;
            objWrpMapDatosDistPaso.blnMuestra = false;    
            objWrpMapDatosDistPaso.blnDefaultColaboraGrupo = mapCodDistObj.containsKey(strDist.Codigo_Distribuidor__c) ? objAdminInvAppDefault.TAM_AplicaColarobarionDefault__c : true;   
            objWrpMapDatosDistPaso.blnModDistRel = false;     
            objWrpMapDatosDistPaso.setFuncDistPrinc = setFuncDistPrincFin;
            objWrpMapDatosDistPaso.setTiposInvenDistPrinc = setTiposInvenDistPrincFin;
            objWrpMapDatosDistPaso.setDistRel = new List<Account>();
            objWrpMapDatosDistPaso.blnTieneReglas = mapCodDistObj.containsKey(strDist.Codigo_Distribuidor__c) ? mapCodDistObj.get(strDist.Codigo_Distribuidor__c) : true;
            //Agregalo a la lista de lWrpMapDatosDist
            lWrpMapDatosDist.add(objWrpMapDatosDistPaso);
        }//Fin del for para lstDistrRel

        System.debug('EN getDatosDistribInv lWrpMapDatosDist: ' + lWrpMapDatosDist);         
        return lWrpMapDatosDist;
    }

    @AuraEnabled
    public static wrpMapDatosDist getObjDatosDistribInv(String recordId, String objClientePrm){
        System.debug('EN getObjDatosDistribInv recordId: ' + recordId  + ' objClientePrm: ' + objClientePrm);
        //Transforma la cadena de objClientePrm en un arregla //{"RecordTypeId":"012i00000002BxyAAE","Id":"001i000001UF9bhAAD","Name":"Toyota Innova Fleteros","Codigo_Distribuidor__c":"57021"}
        String sDatosClientePaso = objClientePrm.replace('{','').replace('}','').replace('"','');
        System.debug('EN getObjDatosDistribInv sDatosClientePaso: ' + sDatosClientePaso);
        String[] arrDatosClienteComa = sDatosClientePaso.contains(',') ? sDatosClientePaso.split(',') : new List<String>();
        System.debug('EN getObjDatosDistribInv arrDatosClienteComa: ' + arrDatosClienteComa);
        String[] arrDatosDist = arrDatosClienteComa[3].contains(':') ? arrDatosClienteComa[3].split(':') : new List<String>();
        System.debug('EN getObjDatosDistribInv arrDatosDist: ' + arrDatosDist);
        String[] arrNomDist = arrDatosClienteComa[1].contains(':') ? arrDatosClienteComa[1].split(':') : new List<String>();
        System.debug('EN getObjDatosDistribInv arrNomDist: ' + arrNomDist);
        String[] arrCodDist = arrDatosClienteComa[2].contains(':') ? arrDatosClienteComa[2].split(':') : new List<String>();
        System.debug('EN getObjDatosDistribInv arrCodDist: ' + arrCodDist);
        
        wrpMapDatosDist objWrpMapDatosDist = new wrpMapDatosDist();
        Set<String> setCveDea = new Set<String>();
        Set<String> setCveDeaEnAdminInv = new Set<String>();
        TAM_AdminInventarioDealer__c objAdminInvDealPaso = new TAM_AdminInventarioDealer__c();
        
        //Agregalos a setCveDea         
        setCveDea.add(arrCodDist[1]); //objClientePrm.Codigo_Distribuidor__c
        System.debug('EN getObjDatosDistribInv setCveDea: ' + setCveDea);

        //Consulta los datos del setCveDea en TAM_AdminInventarioDealer__c 
        for (TAM_AdminInventarioDealer__c objAdminInvDeal : [Select t.id, t.TAM_TipoInventario__c, t.TAM_Funcion__c, 
            t.TAM_DistribuidorAsociado__c, t.TAM_CodigoDistribuidor__c, t.TAM_AplicaColarobarionDefault__c 
            From TAM_AdminInventarioDealer__c t where TAM_CodigoDistribuidor__c IN :setCveDea
            And TAM_Funcion__c = null And TAM_TipoInventario__c = null]){
            objAdminInvDealPaso = objAdminInvDeal;
        }
        System.debug('EN getObjDatosDistribInv objAdminInvDealPaso: ' + objAdminInvDealPaso + ' TAM_AplicaColarobarionDefault__c: ' + objAdminInvDealPaso.TAM_AplicaColarobarionDefault__c);        
                         
        //Agrega el registro del Dist a la list de lWrpMapDatosDist
        wrpMapDatosDist objWrpMapDatosDistPaso = new wrpMapDatosDist();
        objWrpMapDatosDistPaso.NumeroDist = arrCodDist[1]; //objClientePrm.Codigo_Distribuidor__c;
        objWrpMapDatosDistPaso.NombreDist = arrNomDist[1]; //objClientePrm.Name;
        objWrpMapDatosDistPaso.blnMuestra = false;    
        objWrpMapDatosDistPaso.blnDefaultColaboraGrupo = objAdminInvDealPaso.id != null ? objAdminInvDealPaso.TAM_AplicaColarobarionDefault__c : true;   
        objWrpMapDatosDistPaso.blnModDistRel = false;     
        objWrpMapDatosDistPaso.setFuncDistPrinc = setFuncDistPrincFin;
        objWrpMapDatosDistPaso.setTiposInvenDistPrinc = setTiposInvenDistPrincFin;
        objWrpMapDatosDistPaso.setDistRel = new List<Account>();
        objWrpMapDatosDistPaso.blnTieneReglas = setCveDeaEnAdminInv.contains(arrDatosDist[1]) ? false : true; //objClientePrm.Codigo_Distribuidor__c
        
        System.debug('EN getObjDatosDistribInv objWrpMapDatosDistPaso: ' + objWrpMapDatosDistPaso);         
        return objWrpMapDatosDistPaso;
    }

    @AuraEnabled
    public static List<wrpMapDatosDistSelec> getDatosDistribInvSelecc(){
        System.debug('EN getDatosDistribInv lstDistrRel...');
        List<wrpMapDatosDistSelec> lWrpMapDatosDistSelec = new List<wrpMapDatosDistSelec>();
        Map<String, String> mapDelaers = new Map<String, String>();
        Set<String> setNameDist = new Set<String>();
        
        for (TAM_AdminInventarioDealer__c objAdminInv : [Select id, Name, 
             TAM_DistribuidorAsociado__c, TAM_TipoInventario__c, TAM_Funcion__c,
             TAM_CodigoDistribuidor__c, TAM_IdExterno__c 
            From TAM_AdminInventarioDealer__c where TAM_DistribuidorAsociado__c != null
            Order by TAM_CodigoDistribuidor__c]){
            //Toyota del Bajío;Toyota Gunajuato;Toyota Irapuato    
            String[] arrDistribuidorAsociado = objAdminInv.TAM_DistribuidorAsociado__c.split(';');
            //Recorre la lista de arrDistribuidorAsociado y metelos al set de setName
            for (String sNomPaso : arrDistribuidorAsociado){
                setNameDist.add(sNomPaso);            
            }
        }
        System.debug('EN getDatosDistribInv setNameDist: ' + setNameDist);
                
        //Consulta todos los reg de los Dist 
        for (Account objDist : [SELECT Id, Name, Codigo_Distribuidor__c 
            FROM Account WHERE RecordType.Name = 'Distribuidor'
            AND Venta_Corporativa__c = 'Si' AND EstatusDealer__c = 'Activo'
            AND Name IN :setNameDist 
            ORDER BY Name ASC]){
            //Agrega el registro del Dist a la list de lWrpMapDatosDist
            mapDelaers.put(objDist.Name, objDist.Codigo_Distribuidor__c);
        }
        System.debug('EN getDatosDistribInv mapDelaers: ' + mapDelaers);
        
        //Consulta del objeto de TAM_AdminInventarioDealer__c lo que corresponda con setDealer
        for (TAM_AdminInventarioDealer__c objAdminInv : [Select id, Name, 
             TAM_DistribuidorAsociado__c, TAM_TipoInventario__c, TAM_Funcion__c,
             TAM_CodigoDistribuidor__c, TAM_IdExterno__c 
            From TAM_AdminInventarioDealer__c Where TAM_DistribuidorAsociado__c != null
            Order by TAM_CodigoDistribuidor__c]){
                
            //Toma el campo TAM_DistribuidorAsociado__c    
            String[] arrDistribuidorAsociado = objAdminInv.TAM_DistribuidorAsociado__c.split(';');
            String sArrDisFinal = '';
            //Recorre la lista de arrDistribuidorAsociado y metelos al set de setName
            for (String sNomPaso : arrDistribuidorAsociado){
                if (mapDelaers.containsKey(sNomPaso))
                    sArrDisFinal += mapDelaers.get(sNomPaso) + ',' + sNomPaso + ';';     
            }
            System.debug('EN getDatosDistribInv sArrDisFinal: ' + sArrDisFinal);
                
            //Agrega el registro del Dist a la list de lWrpMapDatosDistSelec
            wrpMapDatosDistSelec objWrpMapDatosDistPaso = new wrpMapDatosDistSelec();
            objWrpMapDatosDistPaso.NumeroDist = objAdminInv.TAM_CodigoDistribuidor__c;
            objWrpMapDatosDistPaso.NombreDist = objAdminInv.Name;
            objWrpMapDatosDistPaso.setSelectDistrRel = sArrDisFinal; 
            objWrpMapDatosDistPaso.setSelectFuncDistPrinc = objAdminInv.TAM_Funcion__c != null ? objAdminInv.TAM_Funcion__c : null; 
            objWrpMapDatosDistPaso.setSelectTiposInvenDistPrinc = objAdminInv.TAM_TipoInventario__c != null ? objAdminInv.TAM_TipoInventario__c : null; 
            //Agregalo a la lista de lWrpMapDatosDist
            lWrpMapDatosDistSelec.add(objWrpMapDatosDistPaso);
        }
        System.debug('EN getDatosDistribInv lWrpMapDatosDistSelec: ' + lWrpMapDatosDistSelec);         
        return lWrpMapDatosDistSelec;
    }

    @AuraEnabled
    public static Boolean getUserAdminInven(String recordId){
        System.debug('EN getUserAdminInven...');
        Boolean bUsrAdminInv = false;
        String sPerfilName = '';
        Set<String> setIdUserAdminInv = new Set<String>();
        Boolean blnGestInvAdmin = false;

        for (User usuarioAct : [Select id, Name, City, UserType, ProfileId, 
            Profile.Name, TAM_GestionaInventarioAdmin__c 
            FROM User Where id = :UserInfo.getUserId()]){
            sPerfilName = usuarioAct.Profile.Name;
            blnGestInvAdmin = usuarioAct.TAM_GestionaInventarioAdmin__c;
        }
        
        //Consulta los grupos asociados a setPropVin
        for (GroupMember grupoPublico : [Select g.UserOrGroupId, g.GroupId From GroupMember g
             Where g.Group.Name LIKE '%Admin Inventarios%']){
             setIdUserAdminInv.add(grupoPublico.UserOrGroupId);
        }
        System.debug('EN getUserAdminInven setIdUserAdminInv: ' + setIdUserAdminInv);

        //Ve si el usuario actual existe en el set de setIdUserAdminInv
        if ( setIdUserAdminInv.contains(UserInfo.getUserId()) || sPerfilName.contains('Admin')
            || blnGestInvAdmin)
            bUsrAdminInv = true;
            
        System.debug('EN getUserAdminInven bUsrAdminInv: ' + bUsrAdminInv);
        return bUsrAdminInv;
    }

    @AuraEnabled
    public static TAM_WrpResultadoActualizacion acCreaColaboraDealer(String strDistSelecPrm,
        String lDealesDelFinalPrm, String lWrpMapDatosDistPrm ){
        String[] arrslDealesDelFinalPrmFinal = lDealesDelFinalPrm.contains(',') ? lDealesDelFinalPrm.split(',') : new List<String>();
            
        System.debug('EN acCreaColaboraDealer acCreaColaboraDealer: ' + strDistSelecPrm);
        System.debug('EN acCreaColaboraDealer lDealesDelFinalPrm: ' + lDealesDelFinalPrm);
        System.debug('EN acCreaColaboraDealer lWrpMapDatosDistPrm: ' + lWrpMapDatosDistPrm);
        String lWrpMapDatosDistPrmPaso = lWrpMapDatosDistPrm.contains(',""]') ? lWrpMapDatosDistPrm.replace(',""]',']') : lWrpMapDatosDistPrm;
        //lWrpMapDatosDistPrmPaso = '[{"blnDefaultColaboraGrupo":true,"blnModDistRel":false,"blnMuestra":true,"blnTieneReglas":false,"NombreDist":"Toyota del Bajío","NumeroDist":"57010","setDistRel":[],"setDistrRel":[],"setFuncDistPrinc":[{"value":"Ejecutivo","label":"Ejecutivo"},{"value":"Gestor","label":"Gestor"},{"value":"Asesor","label":"Asesor"}],"setSelectDistrRel":["57213","57303"],"setSelectFuncDistPrinc":[],"setSelectTiposInvenDistPrinc":[],"setTiposInvenDistPrinc":[{"value":"Producción","label":"Producción"},{"value":"Tráfico","label":"Tráfico"},{"value":"Piso","label":"Piso"}]}]';
        //lWrpMapDatosDistPrmPaso = '[{"blnDefaultColaboraGrupo":true,"blnModDistRel":false,"blnMuestra":true,"blnTieneReglas":false,"NombreDist":"Toyota del Bajío","NumeroDist":"57010", "setSelectDistrRel":["65700","57055"]}]';
        System.debug('EN acCreaColaboraDealer lWrpMapDatosDistPrmPaso: ' + lWrpMapDatosDistPrmPaso);

        Set<String> setDealer = new Set<String>();  
        Set<String> setDealerDest = new Set<String>();
        Map<String, map<String, String>> mapCodDeaIdExt = new Map<String, map<String, String>>();
        Map<String, set<String>> mapColInvDoToDf = new Map<String, set<String>>();
        Map<String, String> mapCodDistIdDist = new Map<String, String>();
        Set<String> setDistOrgDistDest = new Set<String>();
        Map<String, wrpMapDatosDistSelecFinal> mapCodDeadPrincObjDatDist  = new Map<String, wrpMapDatosDistSelecFinal>();
        Map<String, TAM_AdminInventarioDealer__c> mapAdminInvDelReglas = new Map<String, TAM_AdminInventarioDealer__c>();

        TAM_WrpResultadoActualizacion objRespoPaso = new TAM_WrpResultadoActualizacion();
        objRespoPaso = new TAM_WrpResultadoActualizacion(false, 'El Inventario se esta actualizando, va a tardar unos minutos..');
                   
        List<wrpMapDatosDistSelecFinal> lWrpMapDatosDistPaso = new List<wrpMapDatosDistSelecFinal>();
        //Recorre el JSON de lWrpMapDatosDistPrm
        JSONParser parser = JSON.createParser(lWrpMapDatosDistPrmPaso);
        while (parser.nextToken() != null){
            if (parser.getCurrentToken() == JSONToken.START_ARRAY){
                while (parser.nextToken() != null){
                    if (parser.getCurrentToken() == JSONToken.START_OBJECT){
                        //Crea un objeto del constructor public AddSubAccountBankInstruction_cls(Long subAccountId, Boolean isDelete, List<bankInstruction> lBankInstruction)
                        wrpMapDatosDistSelecFinal objWrpMapDatosDist = new wrpMapDatosDistSelecFinal();
                        objWrpMapDatosDist = (wrpMapDatosDistSelecFinal) parser.readValueAs(wrpMapDatosDistSelecFinal.class);
                        if (strDistSelecPrm == objWrpMapDatosDist.NumeroDist){
                            System.debug('EN acCreaColaboraDealer objWrpMapDatosDist: ' + objWrpMapDatosDist);
                            lWrpMapDatosDistPaso.add(objWrpMapDatosDist);
                        }//Fin si 
                    }//Fin si parser.getCurrentToken() == JSONToken.START_OBJECT
                }//Fin del parser.nextToken() != null
            }//Fin si parser.getCurrentToken() == JSONToken.START_ARRAY
        }//Fin del mientras parser.nextToken() != null
        System.debug('EN acCreaColaboraDealer lWrpMapDatosDistPaso: ' + lWrpMapDatosDistPaso);
                
        //Ve si la lista de lWrpMapDatosDistPaso tiene algo
        if (!lWrpMapDatosDistPaso.isEmpty()){

	        //Recorre la lista de reg que se modificaron
	        for (wrpMapDatosDistSelecFinal objwrpMapDatosDistSelecFinal : lWrpMapDatosDistPaso){
	            String sIdExterno = objwrpMapDatosDistSelecFinal.NumeroDist;
	            setDealer.add(objwrpMapDatosDistSelecFinal.NumeroDist);
	            //Agregalo al mapa de mapCodDeadPrincObjDatDist
	            mapCodDeadPrincObjDatDist.put(objwrpMapDatosDistSelecFinal.NumeroDist, objwrpMapDatosDistSelecFinal);
                //Separa los datos de los Dealers destino
                for (String sDeaCodDest : objwrpMapDatosDistSelecFinal.setSelectDistrRel){
                    setDealerDest.add(sDeaCodDest);
                }
	        }//Fin del for para lwrpMapDatosDistSelecFinalPaso
	        System.debug('EN acCreaColaboraDealer setDealer: ' + setDealer);
	        System.debug('EN acCreaColaboraDealer setDealerDest: ' + setDealerDest);
	
	        System.debug('EN acCreaColaboraDealer mapCodDeadPrincObjDatDist: ' + mapCodDeadPrincObjDatDist.keyset());
	        System.debug('EN acCreaColaboraDealer mapCodDeadPrincObjDatDist: ' + mapCodDeadPrincObjDatDist.values());

	        //Consulta los Delaer asociados a setDealerDest
	        for (Account delaer : [Select id, Name, Codigo_Distribuidor__c 
	            From Account Where Codigo_Distribuidor__c IN: setDealerDest]){
	            String sName = delaer.Name;    
	            mapCodDistIdDist.put(delaer.Codigo_Distribuidor__c, sName.toUpperCase());
	        }
	        System.debug('EN acCreaColaboraDealer mapCodDistIdDist: ' + mapCodDistIdDist);
	        
	        String sDistFinalCola = '';
	        Map<String, TAM_AdminInventarioDealer__c> mapAdminInvDealerUps = new Map<String, TAM_AdminInventarioDealer__c>();
	        //Recorre la lista de setDistOrgDistDest y crea los registros en el objeto de TAM_AdminInventarioDealer__c      
	        for (String sDistFinal : setDealerDest){
	            String sDistReal = mapCodDistIdDist.containsKey(sDistFinal) ? mapCodDistIdDist.get(sDistFinal) : '';
	            sDistFinalCola += sDistReal +';';
	        }//Fin del for para setDistOrgDistDest
	        System.debug('EN acCreaColaboraDealer sDistFinalCola: ' + sDistFinalCola);
	        
            //Crea el objeto del tipo TAM_AdminInventarioDealer__c
            mapAdminInvDealerUps.put(strDistSelecPrm + ' DistRelMod', new TAM_AdminInventarioDealer__c(
                        Name = strDistSelecPrm + ' DistRelMod',
                        TAM_AplicaColarobarionDefault__c = mapCodDeadPrincObjDatDist.containsKey(strDistSelecPrm) ? mapCodDeadPrincObjDatDist.get(strDistSelecPrm).blnDefaultColaboraGrupo : false,
                        TAM_DistribuidorAsociado__c = sDistFinalCola,
                        TAM_CodigoDistribuidor__c = strDistSelecPrm,
                        TAM_IdExterno__c = strDistSelecPrm + ' DistRelMod',
                        TAM_Procesada__c = false,
                        TAM_Procesar__c = false              
                 )
            );
            System.debug('EN acCreaColaboraDealer mapAdminInvDealerUps: ' + mapAdminInvDealerUps);        
	        
	        //Ve si el dealer regresa a la colaboración por default
	        if (mapCodDeadPrincObjDatDist.containsKey(strDistSelecPrm)){
	           if (mapCodDeadPrincObjDatDist.get(strDistSelecPrm).blnDefaultColaboraGrupo){
		          for (TAM_AdminInventarioDealer__c objAdmInv : [Select t.TAM_TipoInventario__c, TAM_IdExterno__c,
		              t.TAM_Funcion__c, t.TAM_DistribuidorAsociado__c, t.TAM_AplicaColarobarionDefault__c 
		              From TAM_AdminInventarioDealer__c t Where TAM_CodigoDistribuidor__c =:strDistSelecPrm
		              And TAM_Funcion__c != null And TAM_TipoInventario__c != null]){
		              //Metelo al mapa de mapAdminInvDel
		              mapAdminInvDelReglas.put(objAdmInv.TAM_IdExterno__c, new TAM_AdminInventarioDealer__c(id = objAdmInv.id));
		          }//Fin del for para TAM_AdminInventarioDealer__c
	           }//Fin si mapCodDeadPrincObjDatDist.get(strDistSelecPrm).blnDefaultColaboraGrupo
	        }//Fin si mapCodDeadPrincObjDatDist.containsKey(strDistSelecPrm)
            System.debug('EN acCreaColaboraDealer mapAdminInvDelReglas: ' + mapAdminInvDelReglas.KeySet());
            System.debug('EN acCreaColaboraDealer mapAdminInvDelReglas: ' + mapAdminInvDelReglas.Values());
	        	        
	        //Un punto de retorno
	        SavePoint svInv = Database.setSavepoint();
	        
	        String sErrorUpd = '';
	        
	        //Va a mandar a actualizar los registros de mapAdminInvDealerUps
	        List<Database.UpsertResult> ldtSvr = Database.upsert(mapAdminInvDealerUps.values(), TAM_AdminInventarioDealer__c.TAM_IdExterno__c, false);
	        for(Database.UpsertResult objSvr : ldtSvr){
	           if (!objSvr.isSuccess())
	              objRespoPaso = new TAM_WrpResultadoActualizacion(true, 'Hubo un error a la hora de Actualizar el objeto TAM_AdminInventarioDealer__c: ' + objSvr.getErrors()[0].getMessage());
	        }
	
            //Antes de eliminar los registros el mapa de mapAdminInvDelReglas
            if (!mapAdminInvDelReglas.isEmpty()){
                List<TAM_AdminInventarioDealer__c> lAdminInvReglas = new List<TAM_AdminInventarioDealer__c>();                
                for (TAM_AdminInventarioDealer__c objAdmInv : [Select t.TAM_TipoInventario__c, 
                    t.TAM_Funcion__c, t.TAM_DistribuidorAsociado__c, t.TAM_AplicaColarobarionDefault__c 
                    From TAM_AdminInventarioDealer__c t Where TAM_CodigoDistribuidor__c =:strDistSelecPrm
                    And TAM_Funcion__c != null And TAM_TipoInventario__c != null]){
                    //Metelo al mapa de mapAdminInvDel
                    lAdminInvReglas.add(objAdmInv);
                }//Fin del for para TAM_AdminInventarioDealer__c                
                System.debug('EN acCreaColaboraDealer lAdminInvReglas1: ' + lAdminInvReglas);
                //Elimina los registro de las colaboraciones relacionadada    
                List<Database.DeleteResult> ldtSvrDelReg = Database.delete(mapAdminInvDelReglas.values(), false);
                for(Database.DeleteResult objSvrDel : ldtSvrDelReg){
                   if (!objSvrDel.isSuccess())
                      objRespoPaso = new TAM_WrpResultadoActualizacion(true, 'Hubo un error a la hora de eliminar las reglas del objeto TAM_AdminInventarioDealer__c: ' + objSvrDel.getErrors()[0].getMessage());
                }
                for (TAM_AdminInventarioDealer__c objAdmInv : [Select t.TAM_TipoInventario__c, 
                    t.TAM_Funcion__c, t.TAM_DistribuidorAsociado__c, t.TAM_AplicaColarobarionDefault__c 
                    From TAM_AdminInventarioDealer__c t Where TAM_CodigoDistribuidor__c =:strDistSelecPrm
                    And TAM_Funcion__c != null And TAM_TipoInventario__c != null]){
                    //Metelo al mapa de mapAdminInvDel
                    lAdminInvReglas.add(objAdmInv);
                }//Fin del for para TAM_AdminInventarioDealer__c                
                System.debug('EN acCreaColaboraDealer lAdminInvReglas2: ' + lAdminInvReglas);                
                //Elimina la colaboracion reference a esos usuarios 
                bpDepuraColaboraCustomInv(strDistSelecPrm, lAdminInvReglas, true, false);
            }//Fin si !mapAdminInvDelReglas.isEmpty()

            //Antes de eliminar los registros el mapa de mapAdminInvDelReglas
            if (mapAdminInvDelReglas.isEmpty()){
                List<TAM_AdminInventarioDealer__c> lAdminDistRel = new List<TAM_AdminInventarioDealer__c>();                
                for (TAM_AdminInventarioDealer__c objAdmInv : [Select t.TAM_TipoInventario__c, 
                    t.TAM_Funcion__c, t.TAM_DistribuidorAsociado__c, t.TAM_AplicaColarobarionDefault__c 
                    From TAM_AdminInventarioDealer__c t Where TAM_CodigoDistribuidor__c =:strDistSelecPrm]){
                    //Metelo al mapa de mapAdminInvDel
                    lAdminDistRel.add(objAdmInv);
                }//Fin del for para TAM_AdminInventarioDealer__c                
                System.debug('EN acCreaColaboraDealer lAdminDistRel2: ' + lAdminDistRel);
                //Elimina la colaboracion reference a esos usuarios 
                bpDepuraColaboraCustomInv(strDistSelecPrm, lAdminDistRel, true, false);
            }//Fin si !mapAdminInvDelReglas.isEmpty()
	        
	        //Regresa las cosas como estaban
	        if (objRespoPaso.blnEstatus)
	            Database.rollback(svInv);
	
	        /*//Regresa las cosas como estaban
	        if (!objRespoPaso.blnEstatus){
                String sDistFinalColaFin = strDistSelecPrm + ',' + sDistFinalCola.replace(';', ',') + ';';
                System.debug('EN acCreaColaboraDealer sDistFinalColaFin: ' + sDistFinalColaFin);
                //Depura la colaboración
                //bpDepuraColaboracionDealer(sDistFinalColaFin);
                //Crea la colaboración
                //pCreaColaboracionDealer(sDistFinalColaFin);
            }//Fin si !objRespoPaso.blnEstatus*/
                
        }//Fin si !lWrpMapDatosDistPaso.isEmpty()
        
        //Regresa el objeto de la respuesta
        return objRespoPaso;
    }

    @AuraEnabled
    public static TAM_WrpResultadoActualizacion acActualizarDatos(String slWrpMapDatosDistPasoPrm,
        String slDealesDelFinalPrm){ //List<wrpMapDatosDist> lWrpMapDatosDistPaso
        System.debug('EN acActualizarDatos slWrpMapDatosDistPasoPrm: ' + slWrpMapDatosDistPasoPrm);
        String slDealesDelFinalPrmPaso = slDealesDelFinalPrm.replace('[','').replace(']','');
        String[] arrslDealesDelFinalPrmFinal = slDealesDelFinalPrmPaso.split(',');
        System.debug('EN acActualizarDatos slDealesDelFinalPrm: ' + slDealesDelFinalPrm + ' slDealesDelFinalPrmFinal: ' + slDealesDelFinalPrmPaso + ' ' + arrslDealesDelFinalPrmFinal);
        
        String slWrpMapDatosDistPasoPrmPasoFinal = slWrpMapDatosDistPasoPrm.contains('"\\"') ? slWrpMapDatosDistPasoPrm.replace('"\\"','"') : slWrpMapDatosDistPasoPrm;
        String slWrpMapDatosDistPasoPrmPasoFinal2 = slWrpMapDatosDistPasoPrmPasoFinal.contains('\\') ? slWrpMapDatosDistPasoPrmPasoFinal.replace('\\','') : slWrpMapDatosDistPasoPrmPasoFinal;
        String slWrpMapDatosDistPasoPrmPasoFinal3 = slWrpMapDatosDistPasoPrmPasoFinal2.contains('","]') ? slWrpMapDatosDistPasoPrmPasoFinal2.replace('","]','"]') : slWrpMapDatosDistPasoPrmPasoFinal2;
        String slWrpMapDatosDistPasoPrmPasoFinal4 = slWrpMapDatosDistPasoPrmPasoFinal3.contains('""') ? slWrpMapDatosDistPasoPrmPasoFinal3.replace('""','"') : slWrpMapDatosDistPasoPrmPasoFinal3;
        
        slWrpMapDatosDistPasoPrmPasoFinal = slWrpMapDatosDistPasoPrmPasoFinal4; //slWrpMapDatosDistPasoPrmPasoFinal3.substring(0,slWrpMapDatosDistPasoPrmPasoFinal3.length());
        String sslWrpMapDatosDistPasoPrmFinal = slWrpMapDatosDistPasoPrmPasoFinal;
        System.debug('EN acActualizarDatos sslWrpMapDatosDistPasoPrmFinal: ' + sslWrpMapDatosDistPasoPrmFinal);

        Set<String> setDealer = new Set<String>();  
        Set<String> setDealerDest = new Set<String>();
        Map<String, map<String, String>> mapCodDeaIdExt = new Map<String, map<String, String>>();
        Map<String, set<String>> mapColInvDoToDf = new Map<String, set<String>>();
        Map<String, String> mapCodDistIdDist = new Map<String, String>();
        Set<String> setDistOrgDistDest = new Set<String>();
        List<wrpMapDatosDist> lWrpMapDatosDistPaso = new List<wrpMapDatosDist>();

        Map<String, wrpMapDatosDist> mapCodDeadPrincObjDatDist  = new Map<String, wrpMapDatosDist>();

        TAM_WrpResultadoActualizacion objRespoPaso = new TAM_WrpResultadoActualizacion();
        objRespoPaso = new TAM_WrpResultadoActualizacion(false, 'El Inventario se esta actualizando, va a tardar unos minutos..');
        
        //sslWrpMapDatosDistPasoPrmFinal = '[{' +
        //'"blnDefaultColaboraGrupo":true,' +
	    //'"blnMuestra":true,' +
	    //'"NombreDist":"Toyota Aguascalientes Sur",' +
	    //'"NumeroDist":"57208",' +
	    //'"setDistRel":[],' +
	    //'"setDistrRel":[{"value":"57000","label":"TMEX"}],' +
	    //'"setFuncDistPrinc":[' +
	    //'    "Ejecutivo","Gestor","Asesor"' +
	    //'],' +
	    //'"setSelectDistrRel":["65700","57055"], ' +
	    //'"setSelectFuncDistPrinc":[], ' +
	    //'"setSelectTiposInvenDistPrinc":[], ' +
	    //'"setTiposInvenDistPrinc":[ ' +
	    //'    "Producción","Tráfico","Piso" ' +
	    //'],' +
	    //'"blnModDistRel":true' + 
        //'}]';
        
        JSONParser parser = JSON.createParser(sslWrpMapDatosDistPasoPrmFinal);
        while (parser.nextToken() != null){
            if (parser.getCurrentToken() == JSONToken.START_ARRAY){
                while (parser.nextToken() != null){
                    if (parser.getCurrentToken() == JSONToken.START_OBJECT){
                        //Crea un objeto del constructor public AddSubAccountBankInstruction_cls(Long subAccountId, Boolean isDelete, List<bankInstruction> lBankInstruction)
                        TAM_AdminVisibInventarioToyota.wrpMapDatosDist objWrpMapDatosDist = new TAM_AdminVisibInventarioToyota.wrpMapDatosDist();
                        objWrpMapDatosDist = (TAM_AdminVisibInventarioToyota.wrpMapDatosDist) parser.readValueAs(TAM_AdminVisibInventarioToyota.wrpMapDatosDist.class);
                        System.debug('EN acActualizarDatos objWrpMapDatosDist: ' + objWrpMapDatosDist);
                        lWrpMapDatosDistPaso.add(objWrpMapDatosDist);
                    }
                }
            }
        }
        System.debug('EN acActualizarDatos lWrpMapDatosDistPaso: ' + lWrpMapDatosDistPaso);
        
        /*//Recorre la lista de reg que se modificaron
        for (wrpMapDatosDist objWrpMapDatosDist : lWrpMapDatosDistPaso){
            String sIdExterno = objWrpMapDatosDist.NumeroDist;
            setDealer.add(objWrpMapDatosDist.NumeroDist);
            //Agregalo al mapa de mapCodDeadPrincObjDatDist
            mapCodDeadPrincObjDatDist.put(objWrpMapDatosDist.NumeroDist, objWrpMapDatosDist);
            //Ve si cambio alguno de los valores en setDistrRel
            if (objWrpMapDatosDist.blnModDistRel && objWrpMapDatosDist.blnDefaultColaboraGrupo){
                //Separa los datos de los Dealers destino
                for (String sDeaCodDest : objWrpMapDatosDist.setSelectDistrRel){
                    setDealerDest.add(sDeaCodDest);
                }
            }//Fin si objWrpMapDatosDist.blnModDistRel && objWrpMapDatosDist.blnDefaultColaboraGrupo
        }//Fin del for para lWrpMapDatosDistPaso
        System.debug('EN acActualizarDatos setDealer: ' + setDealer);
        System.debug('EN acActualizarDatos setDealerDest: ' + setDealerDest);

        System.debug('EN acActualizarDatos mapCodDeadPrincObjDatDist: ' + mapCodDeadPrincObjDatDist.keyset());
        System.debug('EN acActualizarDatos mapCodDeadPrincObjDatDist: ' + mapCodDeadPrincObjDatDist.values());
        
        //Consulta los Delaer asociados a setDealerDest
        for (Account delaer : [Select id, Name, Codigo_Distribuidor__c 
            From Account Where Codigo_Distribuidor__c IN: setDealerDest]){
            String sName = delaer.Name;    
            mapCodDistIdDist.put(delaer.Codigo_Distribuidor__c, sName.toUpperCase());
        }
        System.debug('EN acActualizarDatos mapCodDistIdDist: ' + mapCodDistIdDist);
        
        //Consulta del objeto de TAM_AdminInventarioDealer__c lo que corresponda con setDealer
        for (TAM_AdminInventarioDealer__c objAdminInv : [Select id, Name, 
             TAM_DistribuidorAsociado__c, TAM_TipoInventario__c, TAM_Funcion__c,
             TAM_CodigoDistribuidor__c, TAM_IdExterno__c 
            From TAM_AdminInventarioDealer__c Where TAM_CodigoDistribuidor__c IN :setDealer]){
            //Si ya existe en el mapa de mapCodDeaIdExt
            if (mapCodDeaIdExt.containsKey(objAdminInv.TAM_CodigoDistribuidor__c))
                mapCodDeaIdExt.get(objAdminInv.TAM_CodigoDistribuidor__c).put(objAdminInv.TAM_IdExterno__c, objAdminInv.TAM_DistribuidorAsociado__c);
            if (!mapCodDeaIdExt.containsKey(objAdminInv.TAM_CodigoDistribuidor__c))
                mapCodDeaIdExt.put(objAdminInv.TAM_CodigoDistribuidor__c , new map<String, String>{objAdminInv.TAM_IdExterno__c => objAdminInv.TAM_DistribuidorAsociado__c});                
        }
        System.debug('EN acActualizarDatos mapCodDeaIdExt: ' + mapCodDeaIdExt);
        
        //Recorre la lista de lWrpMapDatosDistPaso y buscala en mapCodDeaIdExt
        for (wrpMapDatosDist objWrpMapDatosDist : lWrpMapDatosDistPaso){
            String sIdExterno = objWrpMapDatosDist.NumeroDist;
            //Ve si cambio alguno de los valores en setDistrRel
            if (objWrpMapDatosDist.blnModDistRel){
                sIdExterno += ' DistRelMod';
                if (objWrpMapDatosDist.blnModDistRel && objWrpMapDatosDist.blnDefaultColaboraGrupo){
	                if (mapCodDeaIdExt.containsKey(objWrpMapDatosDist.NumeroDist)){
                        System.debug('EN acActualizarDatos VAL 1 sIdExterno: ' + sIdExterno);
	                    if (mapCodDeaIdExt.get(objWrpMapDatosDist.NumeroDist).containsKey(sIdExterno)){
                           System.debug('EN acActualizarDatos VAL 2...');
	                       String sDistAsocia = mapCodDeaIdExt.get(objWrpMapDatosDist.NumeroDist).get(sIdExterno);
	                       String sDistOrgDistDestPaso = objWrpMapDatosDist.NumeroDist + ',';
                           System.debug('EN acActualizarDatos objWrpMapDatosDist.setDistrRel0: ' + objWrpMapDatosDist.setDistrRel);
	                       //Recorre la lista de objWrpMapDatosDist.setDistrRel
	                       for (String sDealSel : objWrpMapDatosDist.setSelectDistrRel){
	                           if (mapCodDistIdDist.containsKey(sDealSel.toUpperCase()))
	                               sDistOrgDistDestPaso += ' ' + mapCodDistIdDist.get(sDealSel) + ',';
	                       } 
	                       sDistOrgDistDestPaso += ';';
	                       String ssDistOrgDistDestPasoFinal = sDistOrgDistDestPaso.replace(',;',';');
	                       //Metelo al set de setDistOrgDistDest 
	                       setDistOrgDistDest.add(ssDistOrgDistDestPasoFinal);
                           System.debug('EN acActualizarDatos ssDistOrgDistDestPasoFinal: ' + ssDistOrgDistDestPasoFinal);
	                    }//Fin si mapCodDeaIdExt.get(objWrpMapDatosDist.NumeroDist).containsKey(sIdExterno     
	                }//Fin si mapCodDeaIdExt.containsKey(objAdminInv.TAM_CodigoDistribuidor__c)
                    if (!mapCodDeaIdExt.containsKey(objWrpMapDatosDist.NumeroDist)){
                        System.debug('EN acActualizarDatos VAL 3...' + objWrpMapDatosDist.NumeroDist);
                        String sDistOrgDistDestPaso = objWrpMapDatosDist.NumeroDist + ',';
                        System.debug('EN acActualizarDatos objWrpMapDatosDist.setSelectDistrRel: ' + objWrpMapDatosDist.setSelectDistrRel);
                        //Recorre la lista de objWrpMapDatosDist.setDistrRel
                        for (String sDealSel : objWrpMapDatosDist.setSelectDistrRel){
                            System.debug('EN acActualizarDatos sDealSel: ' + sDealSel);
                            if (mapCodDistIdDist.containsKey(sDealSel.toUpperCase()))
                                sDistOrgDistDestPaso += ' ' + mapCodDistIdDist.get(sDealSel) + ',';
                        } 
                        sDistOrgDistDestPaso += ';';
                        String ssDistOrgDistDestPasoFinal = sDistOrgDistDestPaso.replace(',;',';');
                        System.debug('EN acActualizarDatos sDistOrgDistDestPaso: ' + sDistOrgDistDestPaso);
                        //Metelo al set de setDistOrgDistDest 
                        setDistOrgDistDest.add(ssDistOrgDistDestPasoFinal);
                    }//Fin si !mapCodDeaIdExt.containsKey(objWrpMapDatosDist.NumeroDist)
                }//Fin si objWrpMapDatosDist.blnModDistRel && objWrpMapDatosDist.blnDefaultColaboraGrupo)
            }//Fin si objWrpMapDatosDist.blnModDistRel
        }//Fin del for para lWrpMapDatosDistPaso
        System.debug('EN acActualizarDatos setDistOrgDistDest1: ' + setDistOrgDistDest);
        
        String sDistFinalCola = '';
        Map<String, TAM_AdminInventarioDealer__c> mapAdminInvDealerUps = new Map<String, TAM_AdminInventarioDealer__c>();
        //Recorre la lista de setDistOrgDistDest y crea los registros en el objeto de TAM_AdminInventarioDealer__c      
        for (String sDistFinal : setDistOrgDistDest){
            String[] arrDistFinal = sDistFinal.split(',');
            String sDistColFinal = '';
            //Recorre la lista de arrDistFinal y toma los distribuiodres
            for (Integer intCntTot = 1; intCntTot < arrDistFinal.size(); intCntTot++){
                sDistColFinal += arrDistFinal[intCntTot] + ';';
            }//Fin del for para arrDistFinal
            String sDistColFinalPuntoComa = sDistColFinal.replace(';;',';');
            System.debug('EN acActualizarDatos ssDistColFinal: ' + sDistColFinal);            
            mapAdminInvDealerUps.put(sDistFinal, new TAM_AdminInventarioDealer__c(
                    Name = arrDistFinal[0] + ' DistRelMod',
                    TAM_AplicaColarobarionDefault__c = mapCodDeadPrincObjDatDist.containsKey(arrDistFinal[0]) ? mapCodDeadPrincObjDatDist.get(arrDistFinal[0]).blnDefaultColaboraGrupo : false,
                    TAM_DistribuidorAsociado__c = sDistColFinalPuntoComa,
                    TAM_CodigoDistribuidor__c = arrDistFinal[0],
                    TAM_IdExterno__c = arrDistFinal[0] + ' DistRelMod',
                    TAM_Procesada__c = false,
                    TAM_Procesar__c = true              
                )
            );
            sDistFinalCola += sDistFinal;
            System.debug('EN acActualizarDatos sDistFinal: ' + sDistFinal);        
        }//Fin del for para setDistOrgDistDest
        System.debug('EN acActualizarDatos sDistFinalCola: ' + sDistFinalCola);        
        System.debug('EN acActualizarDatos mapAdminInvDealerUps: ' + mapAdminInvDealerUps);        
        
        Set<String> setDealDel = new Set<String>();
        Map<String, TAM_AdminInventarioDealer__c> mapAdminInvDel = new Map<String, TAM_AdminInventarioDealer__c>();
        
        //Recorre la lista de arrslDealesDelFinalPrmFinal para crear los reg que se van a eliminar
        for (String sDealDel : arrslDealesDelFinalPrmFinal){
            setDealDel.add(sDealDel.replace('"','') + ' DistRelMod');
        }//Fin del for para 
        System.debug('EN acActualizarDatos setDealDel: ' + setDealDel);        

        for (TAM_AdminInventarioDealer__c objAdmInv : [Select id, TAM_IdExterno__c 
            From TAM_AdminInventarioDealer__c Where TAM_IdExterno__c IN :setDealDel]){
            //Metelo al mapa de mapAdminInvDel
            mapAdminInvDel.put(objAdmInv.TAM_IdExterno__c, new TAM_AdminInventarioDealer__c(id = objAdmInv.id));
        }
        System.debug('EN acActualizarDatos mapAdminInvDel: ' + mapAdminInvDel);        

        for (String sDealDel : setDealDel){
            String ssDealDelPaso = sDealDel.replace(' DistRelMod','');
            sDistFinalCola += ssDealDelPaso + ',;';
        }//Fin del for para 
        System.debug('EN acActualizarDatos sDistFinalCola2: ' + sDistFinalCola);        
                
        //Un punto de retorno
        SavePoint svInv = Database.setSavepoint();
        
        String sErrorUpd = '';
        //Va a mandar a actualizar los registros de mapAdminInvDealerUps
        List<Database.UpsertResult> ldtSvr = Database.upsert(mapAdminInvDealerUps.values(), TAM_AdminInventarioDealer__c.TAM_IdExterno__c, false);
        for(Database.UpsertResult objSvr : ldtSvr){
           if (!objSvr.isSuccess())
              objRespoPaso = new TAM_WrpResultadoActualizacion(true, 'Hubo un error a la hora de Actualizar el objeto TAM_AdminInventarioDealer__c: ' + objSvr.getErrors()[0].getMessage());
        }

        List<Database.DeleteResult> ldtSvrDel = Database.delete(mapAdminInvDel.values(), false);
        for(Database.DeleteResult objSvrDel : ldtSvrDel){
           if (!objSvrDel.isSuccess())
              objRespoPaso = new TAM_WrpResultadoActualizacion(true, 'Hubo un error a la hora de eliminar el objeto TAM_AdminInventarioDealer__c: ' + objSvrDel.getErrors()[0].getMessage());
        }

        //Regresa las cosas como estaban
        if (objRespoPaso.blnEstatus)
            Database.rollback(svInv);

        //Regresa las cosas como estaban
        if (!objRespoPaso.blnEstatus)
            bpDepuraColaboracionDealer(sDistFinalCola);
        */

        
        /*Map<String, TAM_AdminInventarioDealer__c> mapAdminInvDealerUps = new Map<String, TAM_AdminInventarioDealer__c>();
        //Recorre la lista de reg que se modificaron
        for (wrpMapDatosDist objWrpMapDatosDist : lWrpMapDatosDistPaso){
            //Ve si desactivaron la colaboración por default
            if (!objWrpMapDatosDist.blnDefaultColaboraGrupo){
                System.debug('EN acActualizarDatos objWrpMapDatosDist: ' + objWrpMapDatosDist);
                mapAdminInvDealerUps.put(objWrpMapDatosDist.NumeroDist, new TAM_AdminInventarioDealer__c(
                    Name = objWrpMapDatosDist.NumeroDist + ' DistRelMod',
                    TAM_AplicaColarobarionDefault__c = objWrpMapDatosDist.blnDefaultColaboraGrupo,
                    TAM_CodigoDistribuidor__c = objWrpMapDatosDist.NumeroDist,
                    TAM_IdExterno__c = objWrpMapDatosDist.NumeroDist + ' DistRelMod',
                    TAM_Procesada__c = false,
                    TAM_Procesar__c = false              
                    )
                );
            }//Fin si             
        }//Fin del for para lWrpMapDatosDistPaso
        System.debug('EN acActualizarDatos mapCodDeadPrincObjDatDist: ' + mapCodDeadPrincObjDatDist.keyset());
        System.debug('EN acActualizarDatos mapCodDeadPrincObjDatDist: ' + mapCodDeadPrincObjDatDist.values());

        //Un punto de retorno
        SavePoint svInv = Database.setSavepoint();

        List<Database.UpsertResult> ldtSvr = Database.upsert(mapAdminInvDealerUps.values(), TAM_AdminInventarioDealer__c.TAM_IdExterno__c, false);
        for(Database.UpsertResult objSvr : ldtSvr){
           if (!objSvr.isSuccess())
              objRespoPaso = new TAM_WrpResultadoActualizacion(true, 'Hubo un error a la hora de Actualizar el objeto TAM_AdminInventarioDealer__c: ' + objSvr.getErrors()[0].getMessage());
        }

        Database.rollback(svInv);*/
       
        System.debug('EN acActualizarDatos objRespoPaso: ' + objRespoPaso);        
        return objRespoPaso;
    }

    @AuraEnabled
    public static List<wrpReglaColabora> guardaReglaColabora(List<wrpReglaColabora> lWrpReglaColaboraPrm,
        String objWrpMapDatosDistPrm){
        //List<wrpReglaColabora> lWrpReglaColaboraPrm, wrpMapDatosDist objWrpMapDatosDistPrm
        System.debug('ENTRO guardaReglaColabora lWrpReglaColaboraPrm: ' + lWrpReglaColaboraPrm);           
        System.debug('ENTRO guardaReglaColabora objWrpMapDatosDistPrm: ' + objWrpMapDatosDistPrm);           

        Boolean blnExiste = false;    
        Boolean blnNoExisteFunOInvent = false;
        Integer intNoReglaPaso = 1;
            
        List<wrpReglaColabora> lWrpReglaColabora = new List<wrpReglaColabora>();
        wrpReglaColabora objWrpReglaColabora = new wrpReglaColabora();
        
        //Convierte la lista de lWrpReglaColaboraPrm en la lista de 
        objWrpReglaColabora = (TAM_AdminVisibInventarioToyota.wrpReglaColabora) JSON.deserialize(objWrpMapDatosDistPrm, TAM_AdminVisibInventarioToyota.wrpReglaColabora.class);
        System.debug('ENTRO guardaReglaColabora FINAL objWrpReglaColabora: ' + objWrpReglaColabora);           
        
        //Recorre la lista de lWrpReglaColaboraPrm
        if (!lWrpReglaColaboraPrm.isEmpty()){
            System.debug('ENTRO guardaReglaColabora YA TIEN REGLAS LA LISTA lWrpReglaColaboraPrm: ' + lWrpReglaColaboraPrm);           
            Boolean blnExisteFuncion = false;
            Boolean blnExisteInvent = false;
            Boolean blnNoTieneFuncion = true;
            Boolean blnNoTieneInvent = true;
            //Recorre la lista de reglas actuales y ve si la nueva ya existe
            for (wrpReglaColabora objWrpReglaColaboraPaso : lWrpReglaColaboraPrm){
                lWrpReglaColabora.add(objWrpReglaColaboraPaso);
                intNoReglaPaso++;
            }//Fin del for para lWrpReglaColaboraPrm
            //Recorre la lista de reglas actuales y ve si la nueva ya existe
            for (wrpReglaColabora objWrpReglaColaboraPaso : lWrpReglaColabora){
                String strLstFuncSelPaso = objWrpReglaColaboraPaso.lstSelectFuncDistPrinc;
                String strLstTipoInvSel = objWrpReglaColaboraPaso.ltsSelectTiposInvenDistPrinc;
                System.debug('ENTRO guardaReglaColabora YA TIEN REGLAS LA LISTA strLstFuncSelPaso: ' + strLstFuncSelPaso + ' strLstTipoInvSel: ' + strLstTipoInvSel);
	            //Toma las funciones seleccionadas
	            for (String sFuncSelPaso : objWrpReglaColabora.setSelectFuncDistPrinc){
	                //Buscalo en strLstFuncSelPaso
	                if (strLstFuncSelPaso.contains(sFuncSelPaso))
	                   blnExisteFuncion = true;  
	            }//Fin del for para objWrpReglaColabora.setSelectFuncDistPrinc
	            //Toma el Inventa sel            
	            for (String sTipoInvSel : objWrpReglaColabora.setSelectTiposInvenDistPrinc){
                    //Buscalo en strLstFuncSelPaso
                    if (strLstTipoInvSel.contains(sTipoInvSel))
                       blnExisteInvent = true;
	            }//Fin del for para objWrpReglaColabora.setSelectTiposInvenDistPrinc
            }//Fin del for para lWrpReglaColaboraPrm
            System.debug('ENTRO guardaReglaColabora YA TIEN REGLAS LA LISTA blnExisteFuncion: ' + blnExisteFuncion + ' blnExisteInvent: ' + blnExisteInvent);
            //Toma las funciones seleccionadas
            for (String sFuncSelPaso : objWrpReglaColabora.setSelectFuncDistPrinc){
                    blnNoTieneFuncion = false;   
            }
            //Toma el Invemta sel            
            for (String sTipoInvSel : objWrpReglaColabora.setSelectTiposInvenDistPrinc){
                    blnNoTieneInvent = false;   
            }
            //Ve si la funcion y el inventario ya existe
            if (blnExisteFuncion && blnExisteInvent)            
                blnExiste = true;
            //Ve si la funcion y el inventario ya existe
            if (blnNoTieneFuncion || blnNoTieneInvent)            
                blnNoExisteFunOInvent = true;
        }//Fin si !lWrpReglaColaboraPrm.isEmpty()

        //Recorre la lista de lWrpReglaColaboraPrm
        if (lWrpReglaColaboraPrm.isEmpty()){
            System.debug('ENTRO guardaReglaColabora NO TIEN REGLAS LA LISTA lWrpReglaColaboraPrm: ' + lWrpReglaColaboraPrm);           
            Boolean blnNoTieneFuncion = true;
            Boolean blnNoTieneInvent = true;
            //Toma las funciones seleccionadas
            for (String sFuncSelPaso : objWrpReglaColabora.setSelectFuncDistPrinc){
                    blnNoTieneFuncion = false;   
            }
            //Toma el Invemta sel            
            for (String sTipoInvSel : objWrpReglaColabora.setSelectTiposInvenDistPrinc){
                    blnNoTieneInvent = false;   
            }
            //Ve si la funcion y el inventario ya existe
            if (blnNoTieneFuncion || blnNoTieneInvent)            
                blnNoExisteFunOInvent = true;
            System.debug('ENTRO guardaReglaColabora FINAL blnNoTieneFuncion: ' + blnNoTieneFuncion + ' blnNoTieneInvent: ' + blnNoTieneInvent);           

        }//Ests vacia lista de regalas es la primera
        System.debug('ENTRO guardaReglaColabora FINAL blnExiste: ' + blnExiste + ' blnNoExisteFunOInvent: ' + blnNoExisteFunOInvent);           
        
        //Ya existe la combinación en las reglas que ya estan, entonces agregalo a lista de lWrpReglaColabora
        if (blnExiste || blnNoExisteFunOInvent){
            wrpReglaColabora objWrpReglaColaboraFinal = new wrpReglaColabora();
            objWrpReglaColaboraFinal.NumeroDist = objWrpReglaColabora.NumeroDist;
            objWrpReglaColaboraFinal.NombreDist = objWrpReglaColabora.NombreDist;        
            objWrpReglaColaboraFinal.setSelectFuncDistPrinc = objWrpReglaColabora.setSelectFuncDistPrinc;
            objWrpReglaColaboraFinal.setSelectTiposInvenDistPrinc = objWrpReglaColabora.setSelectTiposInvenDistPrinc;
            objWrpReglaColaboraFinal.blnExisteRegla = blnExiste;
            objWrpReglaColaboraFinal.blnNoExisteFunOInvent = blnNoExisteFunOInvent;
            
            String strLstFuncSel = '';
            String strLstTipoInvSel = '';
            //Toma las funciones seleccionadas
            for (String sFuncSelPaso : objWrpReglaColabora.setSelectFuncDistPrinc){
                strLstFuncSel += sFuncSelPaso + ';';
            }
            objWrpReglaColaboraFinal.lstSelectFuncDistPrinc = strLstFuncSel;
            //Toma el Invemta sel            
            for (String sTipoInvSel : objWrpReglaColabora.setSelectTiposInvenDistPrinc){
                strLstTipoInvSel += sTipoInvSel + ';';
            }
            objWrpReglaColaboraFinal.ltsSelectTiposInvenDistPrinc = strLstTipoInvSel;
            objWrpReglaColaboraFinal.intNoRegla = intNoReglaPaso;
            //Agrega el objeto a la lista de 
            lWrpReglaColabora.add(objWrpReglaColaboraFinal);            
        }//Fin si blnExiste
       
        //No existe la combinación en las reglas que ya estan, entonces agregalo a lista de lWrpReglaColabora
        if ( (!blnExiste && !blnNoExisteFunOInvent) || Test.isRunningTest()){
            String strLstFuncSel = '';
            String strLstTipoInvSel = '';
            wrpReglaColabora objWrpReglaColaboraFinal = new wrpReglaColabora();
            objWrpReglaColaboraFinal.NumeroDist = objWrpReglaColabora.NumeroDist;
            objWrpReglaColaboraFinal.NombreDist = objWrpReglaColabora.NombreDist;
            //Toma las funciones seleccionadas
            for (String sFuncSelPaso : objWrpReglaColabora.setSelectFuncDistPrinc){
                strLstFuncSel += sFuncSelPaso + ';';
            }
            objWrpReglaColaboraFinal.lstSelectFuncDistPrinc = strLstFuncSel;
            //Toma el Invemta sel            
            for (String sTipoInvSel : objWrpReglaColabora.setSelectTiposInvenDistPrinc){
                strLstTipoInvSel += sTipoInvSel + ';';
            }
            objWrpReglaColaboraFinal.ltsSelectTiposInvenDistPrinc = strLstTipoInvSel;
            objWrpReglaColaboraFinal.setSelectFuncDistPrinc = objWrpReglaColabora.setSelectFuncDistPrinc;
            objWrpReglaColaboraFinal.setSelectTiposInvenDistPrinc = objWrpReglaColabora.setSelectTiposInvenDistPrinc;
            objWrpReglaColaboraFinal.blnExisteRegla = blnExiste;
            objWrpReglaColaboraFinal.blnNoExisteFunOInvent = blnNoExisteFunOInvent;
            objWrpReglaColaboraFinal.intNoRegla = intNoReglaPaso;            
            //Agrega el objeto a la lista de 
            lWrpReglaColabora.add(objWrpReglaColaboraFinal);
        }

        System.debug('ENTRO guardaReglaColabora FINAL lWrpReglaColabora: ' + lWrpReglaColabora);        
        //Regresa la lista de reglas capturadas
        return lWrpReglaColabora;
    }

    @AuraEnabled
    public static TAM_WrpResultadoActualizacion guardaRecalculaReglasColabora(List<wrpReglaColabora> lWrpReglaColaboraPrm,
        String objWrpMapDatosDistPrm){
        //List<wrpReglaColabora> lWrpReglaColaboraPrm, wrpMapDatosDist objWrpMapDatosDistPrm
        System.debug('ENTRO guardaRecalculaReglasColabora lWrpReglaColaboraPrm: ' + lWrpReglaColaboraPrm);           
        System.debug('ENTRO guardaRecalculaReglasColabora objWrpMapDatosDistPrm: ' + objWrpMapDatosDistPrm);           

        TAM_WrpResultadoActualizacion objRespoPaso = new TAM_WrpResultadoActualizacion();
        objRespoPaso = new TAM_WrpResultadoActualizacion(false, 'El Inventario se esta colaborando, va a tardar unos minutos..');
        wrpReglaColabora objWrpReglaColabora = new wrpReglaColabora();
        Map<String, TAM_AdminInventarioDealer__c> mapAdminInvDealerUps = new Map<String, TAM_AdminInventarioDealer__c>();
        List<TAM_AdminInventarioDealer__c> lAdminInventarioDealer = new List<TAM_AdminInventarioDealer__c>();
        
        //Convierte la lista de lWrpReglaColaboraPrm en la lista de 
        objWrpReglaColabora = (TAM_AdminVisibInventarioToyota.wrpReglaColabora) JSON.deserialize(objWrpMapDatosDistPrm, TAM_AdminVisibInventarioToyota.wrpReglaColabora.class);
        System.debug('ENTRO guardaReglaColabora FINAL objWrpReglaColabora: ' + objWrpReglaColabora);           
                            
        //Recorre la lista de lWrpReglaColaboraPrm
        if (!lWrpReglaColaboraPrm.isEmpty()){
            System.debug('ENTRO guardaRecalculaReglasColabora YA TIEN REGLAS LA LISTA lWrpReglaColaboraPrm: ' + lWrpReglaColaboraPrm);
            //Un objeto del tipo wrpReglaColabora
            wrpReglaColabora objWrpReglaColaboraFinal = new wrpReglaColabora();
            objWrpReglaColaboraFinal.NumeroDist = objWrpReglaColabora.NumeroDist;
            objWrpReglaColaboraFinal.NombreDist = objWrpReglaColabora.NombreDist;

            //Recorre la lista de reglas actuales y ve si la nueva ya existe
            for (wrpReglaColabora objWrpReglaColaboraPaso : lWrpReglaColaboraPrm){
                String sIdExterno = objWrpReglaColaboraPaso.intNoRegla + '-' + objWrpReglaColaboraFinal.NumeroDist;
                //Crea el objeto del tipo TAM_AdminInventarioDealer__c
                mapAdminInvDealerUps.put(sIdExterno, new TAM_AdminInventarioDealer__c(
                        TAM_IdExterno__c = sIdExterno,
                        Name = sIdExterno + ' Regla Custom',
                        TAM_AplicaColarobarionDefault__c = false,
                        TAM_CodigoDistribuidor__c = objWrpReglaColaboraFinal.NumeroDist,
                        TAM_Funcion__c = objWrpReglaColaboraPaso.lstSelectFuncDistPrinc,
                        TAM_TipoInventario__c = objWrpReglaColaboraPaso.ltsSelectTiposInvenDistPrinc,
                        TAM_Procesada__c = false,
                        TAM_Procesar__c = false
                     )
                );
            }//Fin del for para lWrpReglaColaboraPrm
        }//Fin si !lWrpReglaColaboraPrm.isEmpty()
        System.debug('EN guardaRecalculaReglasColabora mapAdminInvDealerUps: ' + mapAdminInvDealerUps);
        
        //Ya tienes la info para crear las reglas hazle un upsert
        //Un punto de retorno
        SavePoint svInv = Database.setSavepoint();
        
        Set<String> setIdAdminInvenCol = new Set<String>(); 
        List<Database.UpsertResult> ldtSvr = Database.upsert(mapAdminInvDealerUps.values(), TAM_AdminInventarioDealer__c.TAM_IdExterno__c, false);
        for(Database.UpsertResult objSvr : ldtSvr){
           if (!objSvr.isSuccess())
              objRespoPaso = new TAM_WrpResultadoActualizacion(true, 'Hubo un error a la hora de Actualizar el objeto TAM_AdminInventarioDealer__c: ' + objSvr.getErrors()[0].getMessage());
           if (objSvr.isSuccess())
              setIdAdminInvenCol.add(objSvr.getId());
        }//Fin del for para ldtSvr
        System.debug('EN guardaRecalculaReglasColabora setIdAdminInvenCol: ' + setIdAdminInvenCol);
        
        //Ve si hay error y entonces hazle un rollback a todo
        if (objRespoPaso.blnEstatus)
            Database.rollback(svInv);
        //Ve si no hay error y entonces hazle un rollback a todo        
        if (!objRespoPaso.blnEstatus){
            String strCodDist = '';
            //Consulta los datos de TAM_AdminInventarioDealer__c
            for (TAM_AdminInventarioDealer__c objAdminInventDealerPaso : [Select Id, TAM_IdExterno__c,
                TAM_CodigoDistribuidor__c, TAM_Funcion__c, TAM_TipoInventario__c, TAM_DistribuidorAsociado__c
                From TAM_AdminInventarioDealer__c Where Id IN: setIdAdminInvenCol]){
                //Agregalo a la lista de lAdminInventarioDealer
                lAdminInventarioDealer.add(objAdminInventDealerPaso);
                strCodDist = objAdminInventDealerPaso.TAM_CodigoDistribuidor__c;
            }//Fin del for  TAM_AdminInventarioDealer__c
            //Ve si hay reglas para colaborar
            if (!lAdminInventarioDealer.isEmpty()){
                System.debug('ENTRO guardaRecalculaReglasColabora ANTES DE QUITAR LA COLABORACION..');
                bpDepuraColaboraCustomInv(strCodDist, lAdminInventarioDealer, true, false);
            }//Fin si !lAdminInventarioDealer.isEmpty()
        }//Fin si !objRespoPaso.blnEstatus
        
        System.debug('ENTRO guardaRecalculaReglasColabora FINAL objRespoPaso: ' + objRespoPaso);        
        return objRespoPaso;
    }

    @AuraEnabled
    public static List<wrpReglaColabora> getReglasColabora(String recordId, String objClientePrm){
        System.debug('EN getReglasColabora recordId: ' + recordId  + ' objClientePrm: ' + objClientePrm);
        //Transforma la cadena de objClientePrm en un arregla //{"RecordTypeId":"012i00000002BxyAAE","Id":"001i000001UF9bhAAD","Name":"Toyota Innova Fleteros","Codigo_Distribuidor__c":"57021"}
        String sDatosClientePaso = objClientePrm.replace('{','').replace('}','').replace('"','');
        System.debug('EN getReglasColabora sDatosClientePaso: ' + sDatosClientePaso);
        String[] arrDatosClienteComa = sDatosClientePaso.contains(',') ? sDatosClientePaso.split(',') : new List<String>();
        System.debug('EN getReglasColabora arrDatosClienteComa: ' + arrDatosClienteComa);
        String[] arrDatosDist = arrDatosClienteComa[3].contains(':') ? arrDatosClienteComa[3].split(':') : new List<String>();
        System.debug('EN getReglasColabora arrDatosDist: ' + arrDatosDist);
        String[] arrNomDist = arrDatosClienteComa[2].contains(':') ? arrDatosClienteComa[2].split(':') : new List<String>();
        System.debug('EN getReglasColabora arrNomDist: ' + arrNomDist);
        
        wrpMapDatosDist objWrpMapDatosDist = new wrpMapDatosDist();
        Set<String> setCveDea = new Set<String>();
        Set<String> setCveDeaEnAdminInv = new Set<String>();
        TAM_AdminInventarioDealer__c objAdminInvDealPaso = new TAM_AdminInventarioDealer__c();
        List<wrpReglaColabora> lWrpReglaColabora = new List<wrpReglaColabora>();
        
        //Agregalos a setCveDea         
        setCveDea.add(arrDatosDist[1]); //objClientePrm.Codigo_Distribuidor__c
        System.debug('EN getReglasColabora setCveDea: ' + setCveDea);

        //Consulta los datos del setCveDea en TAM_AdminInventarioDealer__c 
        for (TAM_AdminInventarioDealer__c objAdminInvDeal : [Select t.id, t.TAM_TipoInventario__c, t.TAM_Funcion__c, 
            t.TAM_DistribuidorAsociado__c, t.TAM_CodigoDistribuidor__c, t.TAM_AplicaColarobarionDefault__c, TAM_IdExterno__c 
            From TAM_AdminInventarioDealer__c t where TAM_CodigoDistribuidor__c IN :setCveDea
            and TAM_Funcion__c != null and TAM_TipoInventario__c != null]){
            String[] strIdExter = objAdminInvDeal.TAM_IdExterno__c.split('-');
            System.debug('EN getReglasColabora strIdExter: ' + strIdExter);            
            //Crea el objeto del tipo wrpReglaColabora
            wrpReglaColabora objWrpReglaColaboraFinal = new wrpReglaColabora();
            objWrpReglaColaboraFinal.NumeroDist = arrDatosDist[1];
            objWrpReglaColaboraFinal.NombreDist = arrNomDist[1];
            objWrpReglaColaboraFinal.lstSelectFuncDistPrinc = objAdminInvDeal.TAM_Funcion__c;
            objWrpReglaColaboraFinal.ltsSelectTiposInvenDistPrinc = objAdminInvDeal.TAM_TipoInventario__c;
            objWrpReglaColaboraFinal.blnExisteRegla = false;
            objWrpReglaColaboraFinal.blnNoExisteFunOInvent = false;
            objWrpReglaColaboraFinal.intNoRegla = strIdExter[0] != null ? Integer.valueOf(strIdExter[0]) : 0;
            //Mete la regla la lista de lWrpReglaColabora            
            lWrpReglaColabora.add(objWrpReglaColaboraFinal);
        }
        
        System.debug('EN getReglasColabora lWrpReglaColabora: ' + lWrpReglaColabora);        
        return lWrpReglaColabora;
    }

    
    @AuraEnabled
    public static TAM_WrpResultadoActualizacion clsRestauraValoresDefault(String strCodDistPrm){
        System.debug('ENTRO clsRestauraValoresDefault strCodDist: ' + strCodDistPrm);           

        TAM_WrpResultadoActualizacion objRespoPaso = new TAM_WrpResultadoActualizacion();
        objRespoPaso = new TAM_WrpResultadoActualizacion(false, 'El Inventario se esta actualizando, va a tardar unos minutos..');
                        
        List<TAM_AdminInventarioDealer__c> lAdminInventarioDealerPrm = new List<TAM_AdminInventarioDealer__c>();    
        //Consulta los datos de TAM_AdminInventarioDealer__c
        for (TAM_AdminInventarioDealer__c objAdminInventDealerPaso : [Select Id, TAM_IdExterno__c,
            TAM_CodigoDistribuidor__c, TAM_Funcion__c, TAM_TipoInventario__c, TAM_DistribuidorAsociado__c
            From TAM_AdminInventarioDealer__c Where TAM_CodigoDistribuidor__c =: strCodDistPrm]){
            //Agregalo a la lista de lAdminInventarioDealer
            lAdminInventarioDealerPrm.add(objAdminInventDealerPaso);
        }//Fin del for  TAM_AdminInventarioDealer__c

        //Elimina todos los reg que existen en TAM_AdminInventarioDealer__c
        List<Database.DeleteResult> ldtSvrDelReg = Database.delete(lAdminInventarioDealerPrm, false);
        for(Database.DeleteResult objSvrDel : ldtSvrDelReg){
           if (!objSvrDel.isSuccess())
              objRespoPaso = new TAM_WrpResultadoActualizacion(true, 'Hubo un error a la hora de eliminar las reglas del objeto TAM_AdminInventarioDealer__c: ' + objSvrDel.getErrors()[0].getMessage());
        }

        //Manda llamar la depuracion completa de todo
        bpDepuraColaboraCustomInv(strCodDistPrm, lAdminInventarioDealerPrm, true, true);
        
        System.debug('ENTRO clsRestauraValoresDefault objRespoPaso: ' + objRespoPaso);
        return objRespoPaso;
                
    }

    /*@AuraEnabled
    public static TAM_WrpResultadoActualizacion acEliminaReglasDist(String strCodDistPrm){
        System.debug('ENTRO acEliminaReglasDist strCodDist: ' + strCodDistPrm);           

        TAM_WrpResultadoActualizacion objRespoPaso = new TAM_WrpResultadoActualizacion();
        objRespoPaso = new TAM_WrpResultadoActualizacion(false, 'El Inventario se esta actualizando, va a tardar unos minutos..');
        
        Set<String> setNomGpo = new Set<String>();
        Map<String, String> mapNomGrupoIdGrupo = new Map<String, String>();
        
        //Consulta los grupos 
        for (Account Dealer : [SELECT ID, Codigo_Distribuidor__c, Name 
            FROM Account WHERE Codigo_Distribuidor__c = :strCodDistPrm ORDER BY NAME]){
            String sName = Dealer.Name;    
            setNomGpo.add(sName.toUpperCase());
            String sNombreGrupo = Dealer.Name;
            sNombreGrupo = Dealer.Name + ' ASESOR';
            setNomGpo.add(sNombreGrupo.toUpperCase());
        }//Fin del for para Account
        System.debug('ENTRO TAM_DepuraColaboraInventBch_cls setNomGpo: ' + setNomGpo);           
                
        //Consulta los grupos 
        for (Group Grupo : [SELECT ID, Name FROM Group WHERE Name IN: setNomGpo ORDER BY NAME]){
            String sNombreGrupo = Grupo.Name;
            mapNomGrupoIdGrupo.put(Grupo.id, sNombreGrupo);
        }
        System.debug('ENTRO acEliminaReglasDist mapNomGrupoIdGrupo: ' + mapNomGrupoIdGrupo.KeySet());           
        System.debug('ENTRO acEliminaReglasDist mapNomGrupoIdGrupo: ' + mapNomGrupoIdGrupo.Values());           

        String sLDealerColaInv = '(';     
        sLDealerColaInv += '\'' + strCodDistPrm.trim() + '\',';
        sLDealerColaInv = sLDealerColaInv.substring(0, sLDealerColaInv.lastIndexOf(','));
        sLDealerColaInv += ')';
        System.debug('EN acEliminaReglasDist sLDealerColaInv: ' + sLDealerColaInv);

        String strVinPrueba = 'JTDKDTB34M1141773';
        String sQuery = 'Select Id, Name, Dealer_Code__c ';
        sQuery += ' From TAM_InventarioVehiculosToyota__c ';
        sQuery += ' where Dealer_Code__c IN ' + sLDealerColaInv;
        sQuery += ' Order by Dealer_Code__c';
        //sQuery += ' Limit 5';

        //Si es una prueba
        if (Test.isRunningTest())
            sQuery += ' Limit 10';
        System.debug('EN acEliminaReglasDist sQuery: ' + sQuery);
        
        //Crea el objeto de objDepuraColaboraInventBch      
        TAM_DepuraColaboraInventDealerBch_cls objDepuraColaboraInventDealerBch = new TAM_DepuraColaboraInventDealerBch_cls(sQuery, strCodDistPrm);
        //No es una prueba entonces procesa de 25 en 25
        if (!Test.isRunningTest())
            Id batchInstanceId = Database.executeBatch(objDepuraColaboraInventDealerBch, 25);

        System.debug('ENTRO acEliminaReglasDist objRespoPaso: ' + objRespoPaso);
        return objRespoPaso;
                
    }

    public static void bpCreaColaboracionDealer(String sDealersColaboraPrm){
        //String sDealersColaboraPrmFinal = sDealersColaboraPrm.replace(';,;',';');
        String sDealersColaboraPrmFinal = sDealersColaboraPrm;
        System.debug('ENTRO bpCreaColaboracionDealer sDealersColaboraPrm: ' + sDealersColaboraPrm + ' sDealersColaboraPrmFinal: ' + sDealersColaboraPrmFinal);           
         
        Set<String> setVodDealer = new Set<String>();
        //57019, TOYOTA AGUASCALIENTES SUR;57213, TOYOTA DEL BAJÍO, TOYOTA GUNAJUATO;
        String[] ssDealerColabora = sDealersColaboraPrm.split(';');
        //Recorre la lista de ssDealerColabora y toma los Distribuidores asocuados a cada Delaer
        for (String sNoDealerPaso : ssDealerColabora){
            String[] ssDealerColaboraFinal = sNoDealerPaso.split(',');
            setVodDealer.add(ssDealerColaboraFinal[0]);
        }//Fin del for para ssDealerColabora
        System.debug('ENTRO EN bpCreaColaboracionDealer setVodDealer: ' + setVodDealer);           

        String sLDealerColaInv = '(';     
        //Recorre la lista de lClientes
        for (String sTipoInv : setVodDealer){
            sLDealerColaInv += '\'' + sTipoInv.trim() + '\',';
        }
        sLDealerColaInv = sLDealerColaInv.substring(0, sLDealerColaInv.lastIndexOf(','));
        sLDealerColaInv += ')';
        System.debug('EN EN bpCreaColaboracionDealer sLDealerColaInv: ' + sLDealerColaInv);

        String strVinPrueba = 'JTDKDTB34M1141773';
        String sQuery = 'Select Id, Name, Dealer_Code__c ';
        sQuery += ' From TAM_InventarioVehiculosToyota__c ';
        sQuery += ' where Dealer_Code__c IN ' + sLDealerColaInv;
        sQuery += ' Order by Dealer_Code__c';
        //sQuery += ' Limit 10';

        //Si es una prueba
        if (Test.isRunningTest())
            sQuery += ' Limit 10';
        System.debug('EN EN bpCreaColaboracionDealer sQuery: ' + sQuery);
        
        //Crea el objeto de  OppUpdEnvEmailBch_cls      
        TAM_CreaColaboraInventBch_cls objCreaColInventBch = new TAM_CreaColaboraInventBch_cls(sQuery, sDealersColaboraPrm);
        //No es una prueba entonces procesa de 25 en 25
        if (!Test.isRunningTest())
            Id batchInstanceId = Database.executeBatch(objCreaColInventBch, 50);        
    }*/

    public static void bpDepuraColaboracionDealer(String sDealersColaboraPrm){
        String sDealersColaboraPrmFinal = sDealersColaboraPrm.replace(',;',';');
        //String sDealersColaboraPrmFinal = sDealersColaboraPrm;
        System.debug('ENTRO bpDepuraColaboracionDealer sDealersColaboraPrm: ' + sDealersColaboraPrm + ' sDealersColaboraPrmFinal: ' + sDealersColaboraPrmFinal);           
         
        Set<String> setVodDealer = new Set<String>();
        //57019, TOYOTA AGUASCALIENTES SUR;57213, TOYOTA DEL BAJÍO, TOYOTA GUNAJUATO;
        String[] ssDealerColabora = sDealersColaboraPrmFinal.split(';');
        //Recorre la lista de ssDealerColabora y toma los Distribuidores asocuados a cada Delaer
        for (String sNoDealerPaso : ssDealerColabora){
            String[] ssDealerColaboraFinal = sNoDealerPaso.split(',');
            setVodDealer.add(ssDealerColaboraFinal[0]);
        }//Fin del for para ssDealerColabora
        System.debug('ENTRO bpDepuraColaboracionDealer setVodDealer: ' + setVodDealer);           

        String sLDealerColaInv = '(';     
        //Recorre la lista de lClientes
        for (String sTipoInv : setVodDealer){
            sLDealerColaInv += '\'' + sTipoInv.trim() + '\',';
        }
        sLDealerColaInv = sLDealerColaInv.substring(0, sLDealerColaInv.lastIndexOf(','));
        sLDealerColaInv += ')';
        System.debug('EN bpDepuraColaboracionDealer.execute sLDealerColaInv: ' + sLDealerColaInv);

        String strVinPrueba = 'JTDKDTB34M1141773';
        String sQuery = 'Select Id, Name, Dealer_Code__c ';
        sQuery += ' From TAM_InventarioVehiculosToyota__c ';
        sQuery += ' where Dealer_Code__c IN ' + sLDealerColaInv;
        sQuery += ' Order by Dealer_Code__c';
        //sQuery += ' Limit 10';

        //Si es una prueba
        if (Test.isRunningTest())
            sQuery += ' Limit 10';
        System.debug('EN bpDepuraColaboracionDealer.execute sQuery: ' + sQuery);
        
        //Crea el objeto de objDepuraColaboraInventBch      
        TAM_DepuraColaboraInventBch_cls objDepuraColaboraInventBch = new TAM_DepuraColaboraInventBch_cls(sQuery, sDealersColaboraPrmFinal);
        //No es una prueba entonces procesa de 25 en 25
        if (!Test.isRunningTest())
            Id batchInstanceId = Database.executeBatch(objDepuraColaboraInventBch, 25);        
    }

    public static void bpDepuraColaboraCustomInv(String strCodDistColabPrm, List<TAM_AdminInventarioDealer__c> lAdminInventarioDealerPrm, Boolean blnDepuraReglas, Boolean blnDepuraGruposRel){
        //String sDealersColaboraPrmFinal = sDealersColaboraPrm.replace(';,;',';');
        System.debug('ENTRO bpDepuraColaboraCustomInv sDealersColaboraPrm: ' + strCodDistColabPrm + ' lAdminInventarioDealerPrm: ' + lAdminInventarioDealerPrm);           
         
        String strVinPrueba = 'JTDKDTB34M1141773';
        String sQuery = 'Select Id, Name, Dealer_Code__c ';
        sQuery += ' From TAM_InventarioVehiculosToyota__c ';
        sQuery += ' where Dealer_Code__c = \'' + String.escapeSingleQuotes(strCodDistColabPrm) + '\'';
        sQuery += ' Order by Dealer_Code__c';
        //sQuery += ' Limit 5';

        //Si es una prueba
        if (Test.isRunningTest())
            sQuery += ' Limit 10';
        System.debug('EN EN bpDepuraColaboraCustomInv sQuery: ' + sQuery);
        
        //Crea el objeto de  OppUpdEnvEmailBch_cls      
        TAM_DepuraColaboraCustomInventBch_cls objDepuraColaboraCustomInventBch = new TAM_DepuraColaboraCustomInventBch_cls(sQuery, strCodDistColabPrm, lAdminInventarioDealerPrm, blnDepuraReglas, blnDepuraGruposRel);
        //No es una prueba entonces procesa de 25 en 25
        if (!Test.isRunningTest())
            Id batchInstanceId = Database.executeBatch(objDepuraColaboraCustomInventBch, 50);        
    }

}